/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package romas.services.movement;

/**
 *
 * @author apaliani
 */

import romas.services.actuator.Definition.*;
import romas.com.data.tables.TABLE;
import romas.com.data.tables.ACTIONS_PROCESS;
import romas.com.data.tables.NOTIFICATIONS_MAP;
import romas.services.NotificationService;
import romas.util.LogWriter;
import java.util.logging.Level;
import java.util.List;
import romas.com.boards.Arduino2009;

public class MovementService extends NotificationService{

    Arduino2009 m_arduino2009;

    public MovementService(romas.com.boards.Arduino2009 arduino2009) throws Exception{
        super("MovementService");
        m_arduino2009 = arduino2009;
    }

    /**
     *For action builder
     *
     * @return the NOTIFICATIONS_MAP record
     */
    public List<NOTIFICATIONS_MAP> prepareAction() {
        return null;
    }




    /**
     * Viene utilizzato questo metodo per eseguire le opeazioni di movimento
     *
     * Execute action
     * @param actionProcess
     * @return
     */
    protected boolean actionWork(ACTIONS_PROCESS actionProcess) {

        if(actionProcess == null) return false;

        LogWriter.writeLog(Level.FINE, TABLE.toString(actionProcess));

        String commandName = config.getPropertiesValue(actionProcess.FULLNAME_ACTION_ACTIONS_PROCESS);

        if(commandName == null || commandName.equals("")){
            LogWriter.writeLog(Level.WARNING, "Param command not found, send command ["+ actionProcess.FULLNAME_ACTION_ACTIONS_PROCESS +"], executed !");
            commandName = actionProcess.FULLNAME_ACTION_ACTIONS_PROCESS;
        }

        try{
            int count = 0;
            // verifico se la scheda  impegnata da un altro servizio
            while(m_arduino2009.busy){
                Thread.sleep(50);
                count++;
                // dopo 2 secondi di attesa considero perso il comando
                if(count == 20)return true;
            }
            m_arduino2009.busy = true;
            m_arduino2009.sendCommand(commandName);

            count = 0;
            // verifico se la scheda ha elaborato il dato
            while(m_arduino2009.lock){
                Thread.sleep(50);
                count++;
                // dopo 2 secondi di attesa considero perso il comando
                if(count == 20)return true;
            }

            return true;
//            // verifico se sto esaminando il sensore richiesto
//            if(commandName.equals(m_arduino2009.processedCommand)){
//                // la notifica avviene in automatico sfruttando il listener del servizio
//                // ritorna il risultato
//                return true;
//            }

        }catch(Exception ex){
            LogWriter.writeLog(Level.SEVERE, ex.getMessage());
        }
        finally{
            // comunque libero la scheda
            m_arduino2009.busy = false;
        }
        // ritorna false se non  andata a buon fine la campionatura
        return false;
    }


    /**
     * Set priority scope
     */
    public int getPriorityScope() {
        return SERVICE_TYPE.SECONDARY_SERVICE;
    }
}
