/*
 * SpeakerService.java
 *
 * Created on 19 marzo 2009, 11.16
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package romas.services.voice;

import java.util.List;
import java.util.logging.Level;

import romas.services.*;
import romas.com.data.tables.*;
import romas.services.voice.Speaker.TYPE;
import romas.util.LogWriter;

/**
 *
 * @author APaliani
 */
public class SpeakerService extends NotificationService{
    
    Speaker mySpeaker = null;

    /** Creates a new instance of SpeakerService */
    public SpeakerService() throws Exception{
        super("SpeakerService");
  
        mySpeaker = new Speaker(config.getPropertiesValue("eSpeak_Path"), super.sleepTime);

        mySpeaker.start();
    }    

    public List<NOTIFICATIONS_MAP> prepareAction() {
         return null;
    }

    
    /**
     *Execute work
     */
    protected boolean actionWork(ACTIONS_PROCESS actionProcess) {
        if(actionProcess == null) return false;
        
        LogWriter.writeLog(Level.FINE, TABLE.toString(actionProcess));

        if(actionProcess.NAME_ACTION_ACTIONS_PROCESS.equals("SPEAK")){
            try{
                // Lettura del testo parametrizzato
                if(actionProcess.COMMAND_ACTIONS_PROCESS.equals("TEXT")){
                    String text = "";
                    if(actionProcess != null){
                        for (int i=0; i<actionProcess.PARAMS_ACTIONS_PROCESS.size(); i++){
                            if(actionProcess.PARAMS_ACTIONS_PROCESS.get(i) != null){
                                if(!actionProcess.PARAMS_ACTIONS_PROCESS.get(i).toString().equals("")){
                                    text += " " + actionProcess.PARAMS_ACTIONS_PROCESS.get(i).toString();
                                }
                            }
                        }
                    }                   
                    return mySpeaker.push(text, TYPE.TEXT);
                }

                // Pronuncia dei file paramaterizzati
                if(actionProcess.COMMAND_ACTIONS_PROCESS.equals("FILE")){
                    if(actionProcess != null){
                        for (int i=0; i<actionProcess.PARAMS_ACTIONS_PROCESS.size(); i++){
                            return mySpeaker.push(actionProcess.PARAMS_ACTIONS_PROCESS.get(i).toString(), TYPE.FILE);
                        }
                    }
                    return true;
                }
            }
            catch(Exception ex){                
                LogWriter.writeLog(Level.SEVERE, ex.getMessage());
                return false;
            }            
        }       
        
        return true;        
    }

    public int getPriorityScope() {
        return SERVICE_TYPE.PRIMARY_SERVICE;
    }
}
