/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package romasBridge;

import java.io.*;
import java.io.InputStream;
import java.net.*;

/**
 *
 * @author apaliani
 */
public class ComunicationClient {

    Socket clientSocket;
    private Socket socket = null;
    private InputStream is;
    private OutputStream os;
    private int nPortServer = 0;
    private String serverName;

    public ComunicationClient(String serverName, int nPortServer){
        this.nPortServer = nPortServer;
        this.serverName = serverName;        
    }

    private void sendMessageLength(int lenght)throws Exception{
        byte[] byteArray = new byte[4];
        byteArray[0] = (byte)((lenght >> 24) & 0xFF);
        byteArray[1] = (byte)((lenght >> 16) & 0xFF);
        byteArray[2] = (byte)((lenght >> 8) & 0xFF);
        byteArray[3] = (byte)(lenght & 0xFF);

        os.write(byteArray);
        os.flush();
    }

    public void sendMessage(String sMessage) throws Exception{
        sendMessageLength(sMessage.length());
        os.write(sMessage.getBytes());
        os.flush();
    }

    private int getLenght()throws Exception{
        byte[] lenBuf = new byte[4];
        is.read(lenBuf, 0, 4);
        int MAX_LENGTH = arr4int (lenBuf, 0);
        return MAX_LENGTH;
    }

    public int arr4int (byte[] arr, int start) {
        int b1 = (int)arr[start]*256*256*256;
        int b2 = (int)arr[start+1]*256*256;
        int b3 = (int)arr[start+2]*256;
        int b4 = (int)arr[start+3];
        int nInt = b1 + b2 + b3 + b4;
        return nInt;
    }

    private String getMessage() throws Exception{
        String reply = "";
        int MAX_LENGTH = getLenght();

        byte[] buf = new byte[MAX_LENGTH];

        int total = 0;

        while (total < MAX_LENGTH) {
            int count = is.read(buf, total, MAX_LENGTH - total);
            if (count < 0) {
                break;
            }
            total += count;
        }

        reply = new String(buf, 0, MAX_LENGTH);
        return reply;
    }

    private void emptyInputStream() throws Exception{
        // empty input stream
        if (is.available() > 0){
            while(is.available() > 0){
                int b = is.read();
            }
        }
    }




    private void connect() throws Exception{
        socket = new Socket(this.serverName, this.nPortServer);
        os = socket.getOutputStream();
        is = socket.getInputStream();
    }

    public boolean connectToRemoteServer() throws Exception {
        try {
            connect();

            Thread.sleep(300);

            String message = getMessage();

            String msSetup = message.substring(0,5);

            if (msSetup.equals("SETUP")){
                //String nDevices = message.substring(6,8);
                //nDevice = Integer.parseInt(nDevices);
                return true;
            }
//            else{
//                LogWriter.writeLog(Level.WARNING, "Message from server: " + message);
//            }
        }
        catch (Exception e) {
            throw new Exception(e.getMessage());
        }
        return false;
    }

}
