/*
 * GoogleMaps.java
 *
 * Created on 24 febbraio 2009, 10.26
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package romas.util.navigator;

/**
 *
 * @author APaliani
 */
import java.io.InputStream;
import java.util.Vector;

import eve.ui.game.AniImage;
import eve.fx.*;
import eve.net.*;
import eve.util.FormattedDataSource;
import eve.sys.*;

import java.net.*;


public class GoogleMaps
{
	String apiKey = null;
 
	//these 2 properties will be used with map scrolling methods. You can remove them if not needed
	int offset = 268435456;
	double radius = offset / Math.PI;
	
	public GoogleMaps(String apiKey){
		this.apiKey = apiKey;
	}
	
	public double[] geocodeAddress(String address) throws Exception{
		byte[] res = loadHttpFile(getGeocodeUrl(address), false);
		
		String resString = new String(res, 0, res.length);
		String[] data = split(resString, ',');
		int test = data[0].indexOf("200");

        if(test < 0){
			int errorCode = Integer.parseInt(data[0]);			
			throw new Exception("Google Maps Exception: " + getGeocodeError(errorCode));
		}
		else
		{
            double[] result = new double[2];
            result[0] = Double.valueOf(data[2]).doubleValue();
            char[] s = data[3].toCharArray();
            String ss = "";
            for(int i=0; i<s.length; i++){
                if(s[i] == 13){
                    break;
                }
                ss += s[i];
            }

            result[1] = Double.valueOf(ss).doubleValue();
			return result;
		}
	}
        
        
	public AniImage retrieveStaticImage(int width, int height, double lat, double lng, int zoom, String format) throws Exception
	{
            String urlMapp = getMapUrl(width, height, lng, lat, zoom, format);
            byte[] bytedata = loadHttpFile(urlMapp, true);

            ImageBytes imageByte = new ImageBytes(bytedata);
            Picture pct = imageByte.pngDecode();
            ImageData imageData = pct.getImageData();

            return new AniImage(imageData);
	}
	
	public String getGeocodeError(int errorCode)
	{
		switch(errorCode)
		{
		case 400:
			return "Bad request";
		case 500:
			return "Server error";
		case 601:
			return "Missing query";
		case 602:
			return "Unknown address";
		case 603:
			return "Unavailable address";
		case 604:
			return "Unknown directions";
		case 610:
			return "Bad API key";
		case 620:
			return "Too many queries";
		default:
			return "Generic error";
		}
	}
	
	public String getGeocodeUrl(String address){
		return "http://maps.google.com/maps/geo?q=" + urlEncode(address) 
			+ "&output=csv&key=" + apiKey;
	}
        
	public String getMapUrl(int width, int height, double lng, double lat, int zoom, String format){
		return "http://maps.google.com/staticmap?center=" + 
			lat + "," + lng + "&format=" + format + "&zoom=" + zoom + "&size=" + 
			width + "x" + height + "&key=" + apiKey;
	}
        
    String urlEncode(String str){
        StringBuffer buf = new StringBuffer();
        char c;
        for(int i = 0; i < str.length(); i++)
        { 
            c = str.charAt(i);
            if ((c >= '0' && c <= '9') || (c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z'))
            {
                buf.append(c);
            }
            else
            {
                buf.append("%").append(Integer.toHexString((int) str.charAt(i)));
            }
        } 
        return buf.toString();
    }
        
        
    public byte[] loadHttpFile(String url, boolean image){
        byte[] byteBuffer = null;
        try{            
            HttpConnection hc = new HttpConnection(url);
            if(!image){
                hc.setRequestorProperty("Content-Type","text/xml;charset=UTF-8");
                hc.setRequestorProperty("User-Agent","EveVM");
            }
            // proxy stuff start 
            //Socket ps = new Socket("151.89.16.100", 8080);
            //hc.setRequestorProperty("Proxy-Connection","Keep-Alive");
            //hc.setRequestorProperty("Proxy-Authorization","Basic "+fnGetBasicAuth(proxuser,proxypw));
            //hc.document = url;
            //hc.setAlreadyOpenSocket(ps);
            // proxy stuff end

            hc.documentIsEncoded = true;
            Socket s = hc.connect(); 
            InputStream in = s.getInputStream();           
            int len = in.available();
            byteBuffer = new byte[len];
            in.read(byteBuffer);
        }
        catch(Exception ex){
            String s = ex.getMessage();
            System.err.println(s);
        }
        return byteBuffer;
    }
        

    static String[] split(String s, int chr){
        Vector res = new Vector();	
        int curr = 0;
        int prev = 0;		
        while((curr = s.indexOf(chr, prev)) >= 0)
        {
                res.addElement(s.substring(prev, curr));			
                prev = curr + 1;
        }
        res.addElement(s.substring(prev));		
        String[] splitted = new String[res.size()];		
        res.copyInto(splitted);	
        return splitted;
    }
}
