package eve.applet;
import java.util.*;

//#####################################################################
public abstract class PathClassInfoLoader implements ClassInfoLoader{
//#####################################################################
/**
* This is a list of all the paths where the classes may be.
**/
public Vector paths = new Vector();
public char pathSeparator = '/';
/**
* Checks to see if 
*/
protected abstract boolean 
//============================================================
  classExists(String fullPathName);
//============================================================
/**
* 
*/
protected abstract boolean 
//============================================================
  getBytesFromPath(ClassInfo ci,String fullPathName);
//============================================================
/**
* 
*/
protected final boolean 
//------------------------------------------------------------
  tryPath(ClassInfo ci,String path)
//------------------------------------------------------------
{
	path = path.replace('\\','/');
	if (!path.endsWith("/")) path = path+'/';
	String fullName = path+ci.fullName.replace('.',pathSeparator)+".class";
	//System.out.println("Trying: "+fullName);
	if (!classExists(fullName)) return false;
	return getBytesFromPath(ci,fullName);
}
//==================================================================
public final boolean getClassBytes(ClassInfo ci)
//==================================================================
{
	for(Enumeration e = paths.elements();e.hasMoreElements();) 
		if (tryPath(ci,(String)e.nextElement())) return true;
	return false;
}
//==================================================================
/**
* This trys to get the bytes for the class. Only this, and nothing more.
*/
//==================================================================
public ClassInfo getClassInfo(String fullClassName)
//==================================================================
{
	ClassInfo ci = new ClassInfo(fullClassName,null);
	ci.fullName = fullClassName;
	if (getClassBytes(ci)) return ci;
	return null;
}
//==================================================================

//#####################################################################
}
//#####################################################################

