package eve.fx.gui;



public class SurfacePointerEvent extends SurfaceEvent implements IEventModifiers
{
/** The event type for a pen or mouse down event - the same as BUTTON_PRESS */
public static final int PEN_DOWN = 200;
/** The event type for a pen or mouse down event - the same as PEN_DOWN */
public static final int BUTTON_PRESS = 200;
/** The event type for a pen or mouse move event - the same as MOUSE_MOVE */
public static final int PEN_MOVE = 201;
/** The event type for a pen or mouse move event - the same as PEN_MOVE */
public static final int MOUSE_MOVE = 201;
/** The event type for a pen or mouse up event - the same as PEN_UP */
public static final int BUTTON_UP = 202;
/** The event type for a pen or mouse up event  - the same as BUTTON_UP */
public static final int PEN_UP = 202;
/** The event type for a pen or mouse drag event - the same as PEN_DRAG */
public static final int MOUSE_DRAG = 203;
/** The event type for a pen or mouse drag event - the same as MOUSE_DRAG */
public static final int PEN_DRAG = 203;
/** The event type for a pen or mouse move on event - the same as PEN_MOVED_ON */
public static final int MOVED_ON = 204;
/** The event type for a pen or mouse move on event - the same as MOVED_ON */
public static final int PEN_MOVED_ON = 204;
/** The event type for a pen or mouse move off event - the same as PEN_MOVED_OFF */
public static final int MOVED_OFF = 205;
/** The event type for a pen or mouse move off event - the same as MOVED_OFF */
public static final int PEN_MOVED_OFF = 205;

/** The event type for when the mouse is hovering over a control. This is not usually
 * generated by the WindowSurface but is created by higher GUI layers.
 */
public static final int MOUSE_HOVER_OVER = 210;
/** The event type for when the mouse is no longer hovering over a control. This is not usually
 * generated by the WindowSurface but is created by higher GUI layers.
 */
public static final int MOUSE_STOP_HOVER = 211;

public static final int SCROLL_UP = 206;
public static final int SCROLL_DOWN = 207;

public static boolean isSurfacePointerEvent(int type)
{
	return type >= PEN_DOWN && type <= MOUSE_STOP_HOVER;
}
/**
 * A possible bit in the "buttons" field. If this bit is set it indicates that the
 * left mouse button is down. If it is a one button mouse this will refer to button 1.
 */
public static final int BUTTON_LEFT = 0x1;
/**
 * A possible bit in the "buttons" field. If this bit is set it indicates that the
 * right mouse button is down.
 */
public static final int BUTTON_RIGHT = 0x2;
/**
 * A possible bit in the "buttons" field. If this bit is set it indicates that the
 * middle mouse button is down.
 */
public static final int BUTTON_MIDDLE = 0x4;
/**
 * A possible bit in the "buttons" field. On X-windows system the scroll-up and
 * scroll-down wheel events are mapped to BUTTON_4 and BUTTON_5 so this is really
 * of little use.
 */
public static final int BUTTON_4 = 0x10;
/**
 * A possible bit in the "buttons" field. On X-windows system the scroll-up and
 * scroll-down wheel events are mapped to BUTTON_4 and BUTTON_5 so this is really
 * of little use.
 */
public static final int BUTTON_5 = 0x20;

/** The x location of the event. */
public int x;

/** The y location of the event. */
public int y;

/**
 * The state of the modifier keys when the event occured. This is a
 * OR'ed combination of the modifiers present in the IKeys interface.
 * @see IKeys
 */
public int modifiers;
/**
 * The state of the button keys when the event occured. This is a
 * OR'ed combination of the BUTTON_XXX values.
 */
public int buttons;
//-------------------------------------------------------------------
//static WeakSet moved = new WeakSet();
//-------------------------------------------------------------------
/**
* It is necessary to call this method if a Control wishes to receive Pen/Mouse movement
* notifications.
* @param who The control requesting notifications.
* @param options any of the WANT_PEN_MOVED_XXX options ORed together.
* @param enable true to enable notification, false to disable them.
*/
/*
//===================================================================
public static void wantPenMoved(Control who,int options,boolean enable)
//===================================================================
{
	if ((Vm.getParameter(Vm.VM_FLAGS) & Vm.VM_FLAG_NO_MOUSE_POINTER) != 0) enable = false;
	if (moved == null) moved = new WeakSet();
	if (!enable) moved.remove(who);
	else moved.add(who);
	if (who.tags == null) who.tags = new TagList();
	setOptions(who,options,0);
}
//-------------------------------------------------------------------
protected static void setOptions(Control who,int toSet,int toClear)
//-------------------------------------------------------------------
{
	int opts = getOptionsFor(who);
	opts &= ~toClear;
	opts |= toSet;
	who.tags.set(WANT_PEN_MOVE_TAG,new Integer(opts));
}
//-------------------------------------------------------------------
static int getOptionsFor(Control who)
//-------------------------------------------------------------------
{
	if (who.tags == null) return 0;
	Tag tg = who.tags.get(WANT_PEN_MOVE_TAG,null);
	if (tg == null) return 0;
	return ((Integer)tg.value).intValue();
}

//===================================================================
static public boolean tipIsDisplayed()
//===================================================================
{
	return false;
}

//-------------------------------------------------------------------
static void topFrameChanging()
//-------------------------------------------------------------------
{
	//FIXME	
}

static Control lastMovedIn = null;
static int lastCursor = 0;
//===================================================================
public static void resetCursor()
//===================================================================
{
	if (lastMovedIn == null) Window.setCursor(null,0);
	else{
		int opts = getOptionsFor(lastMovedIn);
		int cr = opts >> 16;
		if (cr != 0) {
			lastCursor = Window.setCursor(lastMovedIn,cr);
		}
	}
}
*/
}


