/*********************************************************************************
 *  Ewe Virtual Machine - Version 1.14, January 24, 2002                         *
 *  Copyright (C) 1999-2002 Michael L Brereton <michael_brereton@ewesoft.com>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  Under this license, linking this library or part thereof with other files to *
 *  produce an executable does not in itself require the executable to be        *
 *  covered by the GNU Lesser General Public License.                            *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, please download it at: www.ewesoft.com/LGPL.txt                      *
 *                                                                               *
 *********************************************************************************/
package eve.io;

import java.io.IOException;

import eve.sys.Vm;

/**
* This exception is thrown if an attempt to open some stream or file in ReadWrite mode
* was attempted, but only ReadOnly mode is allowed.
**/
//##################################################################
public class ReadOnlyException extends IOException{
//##################################################################

public ReadOnlyException(String msg) {super(msg);}
public ReadOnlyException() {super();}
//===================================================================
public ReadOnlyException(Throwable cause) {super(); Vm.setCause(this,cause);}
//===================================================================
public ReadOnlyException(String message,Throwable cause) {super(message); Vm.setCause(this,cause);}
//===================================================================


//##################################################################
}
//##################################################################

