/*
 * Created on May 10, 2006
 *
 * Michael L Brereton - www.ewesoft.com
 * 
 * 
 */
package eve.ui;

/**
 * @author Michael L Brereton
 *
 */
//####################################################
public class HideControl {
	private static final int disappearSet = Control.ShrinkToNothing;//|Control.Disabled;
	private static final int disappearClear = Control.TakesKeyFocus;

	private int state;
	private Control c;
	private Container p;
	private int hidden;
	
	public int getHiddenLevel()
	{
		return hidden;
	}
	public HideControl(Control control)
	{
		this(control,null);
	}
	
	public HideControl(Control control, Container parent)
	{
		this(control,parent,(control.getModifiers(false) & Control.ShrinkToNothing) == 0);
	}
	
	public HideControl(Control control, Container parent, boolean setVisibility)
	{
		this.c = control;
		this.p = parent;
		setHidden(!setVisibility,false);
	}
	private void relayoutParent(boolean update)
	{
		if (!update) return;
		if (p == null) p = c.getFrame();
		if (p == null) return;
		p.relayout(true);
	}
	public synchronized void hide(boolean update)
	{
		if (hidden == 0){
			state = c.modify(disappearSet,disappearClear);
			relayoutParent(update);
		}
		hidden++;
	}
	public synchronized void unhide(boolean update)
	{
		if (hidden > 0){
			hidden--;
			if (hidden == 0){
				c.restore(state,disappearSet|disappearClear);
				relayoutParent(update);
			}
		}
	}
	public synchronized void setHidden(boolean isHidden, boolean update)
	{
		if (!isHidden){
			if (hidden == 0) return;
			hidden = 1;
			unhide(update);
		}else{
			if (hidden == 0) hide(update);
			hidden = 1;
		}
	}
}

//####################################################
