package eve.ui;
import eve.fx.Color;
import eve.fx.Graphics;
import eve.fx.Point;
import eve.fx.Rect;
import eve.fx.gui.Cursor;

//##################################################################
public class HyperlinkLabel extends Label{
//##################################################################
{
	setCursor(Cursor.HAND_CURSOR);	
	modify(MouseSensitive,0);
}
public HyperlinkLabel(String text) {super(text);}
public HyperlinkLabel(String text,boolean hasHotKey) {super(text,hasHotKey);}
public HyperlinkLabel(int rows,int cols) {super(rows,cols);}

public static Color defaultActiveColor = new Color(0,0,255);
/**
* This is the color for the label when the cursor moves over it. It is initially set
* to defaultActiveColor. You can set it to any color you want.
**/
public Color activeColor = defaultActiveColor;
/**
* This indicates that an action should occur when the pen/mouse is first pressed on the control. If it
* is false, the an action only occurs when the pen/mouse is released after having been pressed on the
* control. By default it is true.
**/
public boolean actionOnPress = false;

public void doPaint(Graphics g,Rect area)
{
	Color prev = foreGround;
	if ((penStatus & PenIsOn) != 0) {
		foreGround = activeColor;
	}
	super.doPaint(g,area);
	foreGround = prev;
}

public void penClicked(Point where)
{
	if (isOnMe(where) && !actionOnPress)
		notifyAction();
}
public void penPressed(Point where)
{
	if (actionOnPress) 
		notifyAction();
}
//##################################################################
}
//##################################################################

