package eve.ui;
/**
 * This is used by ScrollClient and ScrollServer
 * @author Michael L Brereton
 *
 */
//##################################################################
public interface IScroll {
//##################################################################
/** This indicates a Horizontal scroller or a Horizontal scroll action. */
public static final int Horizontal = 1;
/** This indicates a Vertical scroller or a Vertical scroll action. */
public static final int Vertical = 2;
/** 
 * This is an action that indicates the ScrollClient should scroll one page lower -
 * either Horizontally or Vertically as appropriate.
 */
public static final int PageLower = 3;
/** 
 * This is an action that indicates the ScrollClient should scroll one page higher -
 * either Horizontally or Vertically as appropriate.
 */
public static final int PageHigher = 4;
/** 
 * This is an action that indicates the ScrollClient scroll directly to the
 * value provided.
 */
public static final int TrackTo = 5;
/** 
 * This is an action that indicates the ScrollClient should scroll one increment higher -
 * either Horizontally or Vertically as appropriate.
 */
public static final int ScrollHigher = 6;
/** 
 * This is an action that indicates the ScrollClient should scroll one increment lower -
 * either Horizontally or Vertically as appropriate.
 */
public static final int ScrollLower = 7;
public static final int GoLower = 100;
public static final int GoHigher = 101;
/** Specifies that the track will most likely be used in a situation where
there is no mouse or touch screen, so the track should be made small enough
to just indicate the position without regard for the user being able to easily
drag it. */
public static final int OPTION_INDICATOR_ONLY = 0x1;

//##################################################################
}
//##################################################################

