package eve.ui;

import eve.fx.Point;
import eve.fx.Rect;
import eve.ui.event.ControlEvent;
import eve.ui.event.FrameEvent;

public class InputInsideForm extends Form implements PopupController{

	public Input input;
	public InputInsideForm(Input in,int options)
	{
		this.input = in;
		addLast(in);
	}
	
	public int execute(Control parent, int x, int y, int width, int height)
	{
		Frame p = parent.getFrame();
		boolean isWin = false;
		if (p == null){
			Window w = parent.getWindow();
			if (w == null) return IDCANCEL;
			p = w.contents;
			isWin = true;
		}
		FormFrame ff = exec(p,0);
		Point pt = new Point();
		if (!isWin) parent.getPosInParent(p, pt);
		Rect rr = new Rect(x,y,width,height);
		rr.getIntersection(new Rect(0,0,parent.width,parent.height), rr);
		ff.setRect(pt.x+rr.x,pt.y+rr.y,rr.width,rr.height);
		ff.repaintNow();
		return waitUntilClosed();
	}
	
	//==================================================================
	public FormFrame makeFrame(int options)
	//==================================================================
	{
		FormFrame ff = super.makeFrame(options);
		ff.contentsOnly = true;
		ff.borderWidth = 0;
		ff.borderStyle = BDR_NOBORDER;
		ff.popupController = this;
		ff.wantPressedOutside = ff.capturePressedOutside = true;
		return ff;
	}

	public void onControlEvent(ControlEvent ev)
	{
		if (ev.target == input){
			if (ev.type == ev.CANCELLED) exit(IDCANCEL);
			else if (ev.type == ev.PRESSED) exit(IDOK);
		}else if (ev instanceof FrameEvent){
			if (ev.type == FrameEvent.PRESSED_OUTSIDE)
				exit(IDCANCEL);
		}
		
		super.onControlEvent(ev);
	}
	/**
	* This closes the form by exiting with exit code IDCANCEL.
	**/
	//===================================================================
	public void closePopup(int why, int flags)
	//===================================================================
	{
		exit(IDCANCEL);
	}
	
}
