package eve.ui;
import eve.fx.Color;
import eve.fx.Dimension;
import eve.fx.DrawnIcon;
import eve.fx.Font;
import eve.fx.Rect;
import eve.sys.EventListener;
import eve.ui.event.ControlEvent;

//##################################################################
public class InputPopupForm extends ControlPopupForm{
//##################################################################

static InputPopupForm popupForm;

public static synchronized InputPopupForm getPopupForm()
{
	if (popupForm == null) popupForm = new InputPopupForm();
	return popupForm;
}
public int time;
public Input input;
/**@deprecated**/
//public mTextArea area;
public TextPad pad;
public ScrollablePanel areaScroller;
CardPanel cards;
public Label label;
{
	quickRecalculate = true;
}
//===================================================================
public InputPopupForm()
//===================================================================
{
	backGround = Color.White;
	CellPanel top = new CellPanel();
	label = new Label("Prompt");
	label.backGround = new Color(0,0,0xff);
	label.foreGround = Color.White;
	label.borderStyle = BDR_OUTLINE|BF_TOP|BF_LEFT|BF_RIGHT;
	label.borderColor = Color.Black;
	label.setPreferredSize(10,20);
	label.anchor = label.CENTER;
	//addLast(label).setCell(HSTRETCH);
	
	Button b = new Button(); cancel = b;
	b.borderStyle = BDR_OUTLINE|BF_TOP|BF_LEFT|BF_BOTTOM;
	b.image = new DrawnIcon(DrawnIcon.CROSS,10,10,new Color(0x80,0,0));
	top.addNext(b).setCell(DONTSTRETCH);
	top.addNext(label);
	addLast(top).setCell(HSTRETCH);
	cards = new CardPanel();
	cards.borderWidth = 1;
	cards.borderColor = Color.Black;
	cards.borderStyle = BDR_OUTLINE|BF_RECT;
	addNext(cards);
	
	input = new Input();
	input.borderWidth = 0;
	input.borderStyle = BDR_NOBORDER;//BDR_OUTLINE|BF_RECT;
	input.wantReturn = true;
	//input.borderColor = Color.Black;

	pad = new TextPad(4,4);
	pad.borderWidth = 0;
	pad.borderStyle = BDR_NOBORDER;//BDR_OUTLINE|BF_RECT;
	//area.borderColor = Color.Black;
	
	cards.addItem(input,"Input",null);
	cards.addItem(areaScroller = new ScrollBarPanel(pad),"Area",null);

	b = new Button(); ok = b;
	b.borderStyle = BDR_OUTLINE|BF_TOP|BF_RIGHT|BF_BOTTOM;
	b.image = new DrawnIcon(DrawnIcon.TICK,10,10,new Color(0,0x80,0));
	//addNext(b).setCell(DONTSTRETCH);
	top.addNext(b).setCell(DONTSTRETCH);
}

protected static boolean popped = false;
//===================================================================
public boolean popup(Control forWho,Rect visible)
//===================================================================
{
	client = forWho;
	Dimension d = forWho.getSize(null);
	
	Rect r = getCachedRect();
	try{
		Rect isVisible = Gui.visibleWindowClientArea(forWho,r);
		if (isVisible == null) isVisible = new Rect(0,0,0,0);
		/*
		if (isVisible.height < d.height || isVisible.width < 50) {
			return false;
		}
		*/
		if (d.width > isVisible.width) d.width = isVisible.width;
		Rect tr = new Rect(isVisible.x+(visible.width-d.width)/2,isVisible.y+(visible.height-d.height)/2,d.width,d.height);
		int options = (forWho instanceof TextPad) ? MULTILINE : 0;
		if (forWho instanceof Input)
			if (((Input)forWho).isPassword) options |= PASSWORD;
		return popup(forWho.getText(),options,null/*tr*/,forWho.getFont(),forWho,forWho.getPrompt());
	}finally{
		cache(r);
	}
}

int labelHeight = 0;
//===================================================================
public void make(boolean reMake)
//===================================================================
{
	super.make(reMake);
	labelHeight = label.getPreferredSize(null).height;
}
public static final int MULTILINE = 0x1;
public static final int PASSWORD = 0x2;

int lastOpts;
//===================================================================
public boolean popup(String value,int options,Rect textRect,Font textFont,EventListener listener,String prompt)
//===================================================================
{
	//time = ewe.sys.Vm.getTimeStamp();
	if (popped) return false;
	popped = true;
	 
	lastOpts = options;
	
	if (listeners != null) listeners.clear();
	if (listener != null) {
		addListener(listener);
	}
	
	boolean multiLine = ((options & MULTILINE) != 0);
	EditControl c = multiLine ? (EditControl)pad : (EditControl)input;
	if (textFont != null) c.font = textFont;
	c.setText(value);
	Frame parent = Gui.windowFrame(client);
	Rect vca = getCachedRect();
	try{
		Rect ma = Gui.visibleWindowClientArea(client,vca);//mApp.mainApp.getRect();
		//if (textRect == null) 
		textRect = new Rect().set(ma.x+5,ma.y+(multiLine ? 25 : 4),ma.width-10,multiLine ? ma.height-30 : 20);
		//if (MULTILINE) 
		cards.setPreferredSize(textRect.width+input.spacing*2,textRect.height+input.spacing*2);
	
		//Frame f = exec(client.getFrame(),null,0);
		Frame f = exec(parent,0);
		f.modify(Invisible,0);
		int lh = (prompt == null) ? 0 : labelHeight;
		label.text = prompt != null ? prompt : "";
		//label.setPreferredSize(0,lh);
		
		if (c == input) {
			input.isPassword = ((options & PASSWORD) != 0);
			cards.select(0);
		}else cards.select(1);
		
		f.modifyAll(AlwaysRecalculateSizes,0,true);
		f.quickRecalculate = true;
		
		Dimension r = f.getPreferredSize(null);
		if (r.width > ma.width) r.width = ma.width;
		if (r.height > ma.height) r.height = ma.height;
		int y = textRect.y-input.spacing-lh;
		int x = textRect.x-input.spacing;
		if (y+r.height > ma.height) y = ma.height-r.height;
		if (x + r.width > ma.width) x = ma.width-r.width;
		//ewe.sys.Vm.debug(ma+", "+r+", "+textRect);
		if (x < 0) x = 0;
		if (y < 0) y = 0;
		f.setRect(x,y,r.width,r.height);
		f.modify(0,Invisible);
		f.repaintNow();
		//c.selectAll();
		Gui.takeFocus(c,ByRequest);
		return true;
		//time = ewe.sys.Vm.getTimeStamp()-time;
	}finally{
		cache(vca);
	}
}

//===================================================================
public void onControlEvent(ControlEvent ev)
//===================================================================
{
	if (ev.target == input){
		if (ev.type == ev.PRESSED)
			exit(IDOK);
		else if (ev.type == ev.CANCELLED)
			exit(IDCANCEL);
	}
	else super.onControlEvent(ev);
}
//===================================================================
public void close(int retVal)
//===================================================================
{
	Gui.setSIP(getWindow(),0);
	super.close(retVal);
	popped = false;
}
//===================================================================
public String getNewText() 
//===================================================================
{
	Control c = ((lastOpts & MULTILINE) != 0) ? (Control)pad : (Control)input;
	return c.getText();
}
//##################################################################
}
//##################################################################

