package eve.ui;
import eve.fx.Dimension;
import eve.fx.Point;
import eve.fx.Rect;
import eve.sys.Event;
import eve.sys.EventListener;
import eve.ui.event.ControlEvent;
import eve.ui.event.FrameEvent;
import eve.ui.event.MenuEvent;
/*
// header - edit "Data/yourJavaHeader" to customize
// contents - edit "EventHandlers/Java file/onCreate" to customize
//
*/
public class MenuState implements EventListener, PopupController
{
public Menu menu;
public Frame parent;
public CarrierFrame frame;
public Control control;
public boolean opened = false;
public boolean outsideOfControl = true;
public boolean isOpen() {return opened;}
public boolean autoSelectFirst = false;
public String title;
public boolean fade;

public MenuState()
{
}
//-------------------------------------------------------------------
protected void showIt()
//-------------------------------------------------------------------
{
}
//===================================================================
public void doShowMenu(Point p)
//===================================================================
{
	doShowMenu(p,true,outsideOfControl ? control.getDim(null) : null);
/*
	ewe.sys.Vm.setSIP(0);
	opened = true;
	menu.selectedIndex = -1;
	menu.borderWidth = 0;
	menu.firstItem = 0;
	Rect r = control.getDim(null);
	Frame p = control.getFrame();
	frame = menu.getCarrierFrame(control,0,0,false,false,p);
	Point myLoc = Gui.getPosInParent(control,p);
	frame.putInFrame(myLoc.x,myLoc.y+r.height,myLoc.y-1);
	showIt();
*/
}
static Point where = new Point();
private Dimension dbuff; 
public void doShowMenu(Point point,boolean center,Rect exclusion)
{
	if (!control.checkMenu(menu)) return;
	where.set(point.x,point.y);
	//if (!control.hasModifier(control.KeepSIP,false)) ewe.sys.Vm.setSIP(0);
	if (exclusion == null) exclusion = new Rect(where.x,where.y,2,12);
	opened = true;
	menu.selectedIndex = -1;
	menu.borderWidth = 0;
	menu.firstItem = 0;
	menu.autoSelectFirst = autoSelectFirst;
	Rect r = control.getDim(null);
	Frame p = Gui.getPopupMenuParentFrame(control);
	menu.popupController = this; 
	frame = menu.getCarrierFrame(control,0,0,false,false,p,title);
	Point myLoc = Gui.getPosInParent(control,p,Point.getCached(0,0));
	Rect fd = frame.getDim(Rect.getCached());
	try{
	if (control != null)
		if ((control.getModifiers(false) & Control.MakeMenuAtLeastAsWide) != 0){
			if (dbuff == null) dbuff = new Dimension();
			control.getSize(dbuff);
			if (fd.width < dbuff.width) {
				fd.width = dbuff.width;
				frame.resizeTo(fd.width,fd.height);
			}
		}
	int xp = where.x+myLoc.x; 
	if (center) xp -= fd.width/2;
	int yp = where.y+myLoc.y;
	if (yp < exclusion.y+exclusion.height+myLoc.y)
		yp = exclusion.y+exclusion.height+myLoc.y;
	int of = frame.modify(Control.Invisible,0);
	int oc = control.modify(Control.Invisible,0);
	frame.putInFrame(xp,yp,exclusion.y+myLoc.y);
	Gui.takeFocus(menu,Control.ByRequest);
	//if (autoSelectFirst && menu.selectedIndex == -1)
		//menu.selectNext();
	menu.inheritModifiers(control,true,control.AlwaysEnabled|control.NotAnEditor|control.KeepImage,true);
	control.restore(oc,Control.Invisible);
	control.repaintNow();
	frame.modify(0,Control.Invisible);
	if (fade){
		ControlFader cf = new ControlFader(frame,0.1,50,10);
		cf.start();
	}else
		frame.repaintNow();
	frame.addListener(this);
	menu.addListener(this); 
	menu.stateChanged(true);
	Control.popupBeep();
	control.postEvent(new ControlEvent(ControlEvent.MENU_SHOWN,control));
	showIt();
	}finally{
		myLoc.cache();
		fd.cache();
	}
}

//===================================================================
public void closePopup(int why, int flags)
//===================================================================
{
	doCloseMenu();
	Control c = control;
	c.popupMenuClosed(menu);
	c.postEvent(new ControlEvent(ControlEvent.POPUP_CLOSED,c));
}
public void closeMenu()
{
	closePopup(0,0);
}
//===================================================================
private synchronized void doCloseMenu()
//===================================================================
{
	menu.noMenu();
	Gui.hideFrame(frame);
	control.deactivate();
	frame.removeListener(this);
	menu.removeListener(this);
	menu.stateChanged(false);
	frame.popupController = null;
	frame = null;
	opened = false;
}
//------------------------------------------------------------------
public void onEvent(Event ev)
//------------------------------------------------------------------
{
	Control c = control;
	if ((ev.type == MenuEvent.SELECTED || ev.type == MenuEvent.ABORTED) && ev.target == menu){
		Object it = ((MenuEvent)ev).selectedItem;
		if (it instanceof MenuItem) c.lastSelected = (MenuItem)it;
		doCloseMenu();
		c.onEvent(ev); //This lets the control process it internally.
		ev.target = c;
		c.postEvent(ev); //This lets other controls process it.
		if (!c.hasModifier(c.NoFocus,false))
			Gui.takeFocus(c,control.ByRequest);
		c.popupMenuClosed(menu);
		c.postEvent(new ControlEvent(ControlEvent.POPUP_CLOSED,c));
	}else if (ev.type == FrameEvent.PRESSED_OUTSIDE && (ev instanceof FrameEvent)){
		//System.out.println("Outside!");
		Point onScreen = (Point)((FrameEvent)ev).data;
		if (true || !Gui.getAppRect(c).isInside(onScreen.x,onScreen.y)){
			doCloseMenu();
			MenuEvent me = new MenuEvent(MenuEvent.ABORTED,menu,null);
			c.onEvent(me);
			c.popupMenuClosed(menu);
			c.postEvent(new ControlEvent(ControlEvent.POPUP_CLOSED,c));
		}
	}
}

}
