package eve.ui;

//##################################################################
public interface MultiPanel{
//##################################################################
/**
* This adds a control to the MultiPanel with a specified short (Tab) name and
* optional long name. 
* 
* When an item is added a Card object is created to hold information about
* the item. 
* The item to be added is first added to a CellPanel before being placed
* int the panel. It may be added in a ScrollableHolder or other such
* container before being added to the CellPanel.
**/
public Control addItem(Control item,String tabName,String longName);
/**
* This selects for display one of the previously added Controls.
**/
public void select(Control item);
/**
* This selects for display one of the previously added Controls, given the
* short (tab) name for the item.
**/
public void select(String tabName);
/**
* This selects for display one of the previously added Controls, given the
* index of the item.
**/
public void select(int index);
/**
* This returns the index for the currently selected item. It will return -1 if
* none is currently selected.
**/
public int getSelectedItem();
/**
* This returns the number of items added to the MultiPanel.
**/
public int getItemCount();
//##################################################################
}
//##################################################################

