package eve.ui;
/**
 * This interface is implemented usually be a Control which provides the user with
 * controls for scrolling client data horizontally or vertically or both.
 * @author Michael L Brereton
 *
 */
//##################################################################
public interface ScrollServer extends IScroll{
//##################################################################
/**
 * This method tells the ScrollServer to check the state of the ScrollClient
 * to determine if it needs to update its on-screen scroll controls. 
 */
public void checkScrolls();
/**
 * This method tells the ScrollServer to update a particular scrolling control.
 * @param which either Horizontal or Vertical.
 */
public void updateScroll(int which);
/**
 * This returns the ScrollClient of the ScrollServer.
 */
public ScrollClient getClient();
//##################################################################
}
//##################################################################

