package eve.ui;
import eve.fx.BufferedGraphics;
import eve.fx.Color;
import eve.fx.Graphics;
import eve.fx.IImage;
import eve.fx.Image;
import eve.fx.Point;
import eve.fx.Rect;

//##################################################################
public class Sprite{
//##################################################################

Control lastDrawn;
Point lastPoint = new Point();
public IImage image;

//===================================================================
public Sprite(IImage image) {this.image = image;}
public Sprite(int width,int height,Color color) 
{
	image = new Image(width,height);
	Graphics g = new Graphics((Image)image);
	g.setColor(color == null ? Color.Black : color);
	g.fillRect(0,0,width,height);
	g.free();
}
//===================================================================

//-------------------------------------------------------------------
void draw(Control who,int x,int y,int op)
//-------------------------------------------------------------------
{
	lastDrawn = who;
	lastPoint.set(x,y);
	if (who == null) return;
	BufferedGraphics gr = who.getGraphics(x,y,image.getWidth(),image.getHeight());
	if (gr == null) return;
	Graphics g = gr.getGraphics();
	g.setDrawOp(op);
	image.draw(g,x,y,0);
	gr.release();
}
Rect refresh = new Rect();
boolean inMove = false;
//===================================================================
public void moveTo(Control who,int x,int y)
//===================================================================
{
	if (inMove) return;
	try{
	inMove = true;
	if (who == lastDrawn && x == lastPoint.x && y == lastPoint.y){
 		return;
	}
	if (lastDrawn != null) {
		lastDrawn.repaintNow(null,refresh.set(lastPoint.x,lastPoint.y,image.getWidth(),image.getHeight()));//draw(lastDrawn,lastPoint.x,lastPoint.y,Graphics.DRAW_XOR);
		//ewe.sys.Vm.debug(refresh.toString());
	}
	draw(who,x,y,Graphics.DRAW_OVER);
	}finally{
		inMove = false;
	}
}
//##################################################################
}
//##################################################################


