/*
 * Created on Feb 28, 2006
 *
 * Michael L Brereton - www.ewesoft.com
 * 
 * 
 */
package eve.ui;

import eve.fx.gui.RawEvent;
import eve.sys.Device;
import eve.sys.Event;
import eve.sys.TimeOut;

/**
 * @author Michael L Brereton
 *
 */
//####################################################
class WindowRawEventThread extends Thread{

Window window;
boolean closed = false;
boolean firstEvent = true;
RawEvent gotEvent;
boolean eventUsed;
int posted, rxed;

WindowRawEventThread(Window window)
{
	this.window = window;
	start();
}

synchronized void queueEvent(Event ev)
{
	//posted++;
	window.surface.postEvent(ev);
}
synchronized void clearOldEvent()
{
	if (gotEvent != null && eventUsed){
		gotEvent.inUse = false;
		gotEvent = null;
		eventUsed = false;
		notifyAll();
	}
}

public void run()
{
	Device.setThreadIsEventHandler();
	int num = 0;
try{
	while(!closed){
		try{
			//System.out.println("++"+window);
			RawEvent re = window.surface.getRawEvent(TimeOut.Forever);
			/* Testing expired timeout. Works fine.
			if (re == null){
				System.out.println("Nothing!");
				continue;
			}
			*/
			//if (re.rawEventType == re.POINTER_EVENT && re.surfaceEventType == SurfacePointerEvent.PEN_DOWN) System.out.println(++num);
			//System.out.println("--"+window);
			synchronized(this){
				gotEvent = re;
				eventUsed = false;
				notifyAll();
				while(gotEvent != null && !closed){
					try{
						wait();
					}catch(InterruptedException e){
						//e.printStackTrace();
					}
				}
			}
		}catch(InterruptedException e){
			//e.printStackTrace();
			//
			// Interrupted while waiting for a SurfaceEvent.
			//
			continue;
		}
	}
}finally{
	//System.out.println(window+"- rawEventGetter exiting!");
}
}

}
//####################################################
