package eve.ui.data;

import eve.data.DataUnit;
import eve.data.Named;
import eve.fx.IImage;
import eve.util.TextEncodable;

/**
* A LiveData is a more complex version of a DataUnit. In addition to the
* functionality of a DataUnit, a LiveData can also:<br>
* <pre>
* 1. Provide a visual means of editing its data.
* 2. Encode and Decode its internal data as a text String.
* 3. Provide a Name for itself (for displaying in a list).
* 4. Provide an icon (IImage object) if one is associated with it.
*</pre>
**/
//##################################################################
public interface LiveData extends DataUnit, TextEncodable, FieldListener, Named{
//##################################################################
/**
* Return a ewe.ui.Editor Object which can be used to visually edit
* the information in this LiveData object.
**/
public Editor getEditor(int options);
/**
* Encode this Object as a string.
**/
//public String textEncode();
/**
* Decode this Object for a String previously encoded using textEncode()
**/
//public void textDecode(String from);
/**
* Return an Icon for this object (if one exists) or null if no icon exists.
**/
public IImage getIcon();
//##################################################################
}
//##################################################################

