package eve.ui.filechooser;
import eve.fx.gui.IKeys;
import eve.io.File;
import eve.sys.Vm;
import eve.ui.Application;
import eve.ui.CellPanel;
import eve.ui.CheckBox;
import eve.ui.Choice;
import eve.ui.Form;
import eve.ui.Input;
import eve.ui.InputStack;
import eve.ui.MessageBox;
import eve.ui.data.Editor;
import eve.ui.data.LiveObject;
import eve.util.mString;

//##################################################################
public class FileChooserDemo extends LiveObject implements Runnable{
//##################################################################

public boolean
	showTree = false, 
	quickSelect = false, 
	useImages = false, 
	browseOnly = true, 
	multiSelect = false, 
	explorer = false;
	
public String chooserTitle = "File Chooser";
public String title = "FileChooser Demo Options";
public String masks = "";
public int type = 0;
public boolean asABrowser = false;
public boolean doExec = true;//false;

//===================================================================
public void addToPanel(CellPanel cp,Editor f,int which)
//===================================================================
{
	//Vm.debugStackTrace();
	//f.windowFlagsToClear = Window.FLAG_HAS_CLOSE_BUTTON;
	f.title = title;
	//cp.addLast(new CheckBox("Tester$e"));
	InputStack is = new InputStack();
	if (!asABrowser){
		is.add(f.addField(new Choice(new String[]{"File(s)","Directory"},0),"type"),"Chooser Type");
		cp.addLast(is).setCell(f.HSTRETCH);
	}
	is = new InputStack(); //is.columns = 2;
	is.add(f.addField(new CheckBox(),"showTree"),"Directory Tree");
	is.add(f.addField(new CheckBox(),"useImages"),"Image Preview");
	if (!asABrowser){
		is.add(f.addField(new CheckBox(),"multiSelect"),"Multi-Select");
		is.add(f.addField(new CheckBox(),"browseOnly"),"Browse Only");
		is.add(f.addField(new CheckBox(),"explorer"),"Explorer");
		is.add(f.addField(new CheckBox(),"quickSelect"),"Quick Select");
		//if (Gui.screenIs(Gui.WIDE_SCREEN))
		is.add(f.addField(new Input(),"masks"),"File Masks:");
	}
	cp.addLast(is).setCell(f.HSTRETCH);
	f.doButtons(f.DEFOKB|f.DEFCANCELB);
	f.cancel.setHotKey(0,IKeys.ESCAPE);
	f.exitButtonDefined = true;
	f.setTextSize(title.length(),-1);
}
boolean exitSystem = false;

//===================================================================
public void runDemo(boolean xs){
//===================================================================
	exitSystem = xs;
	new Thread(this).start();
}

public File aFile = Vm.newFileObject();
public String initial = File.getProgramDirectory();

void runIt()
{
	//rot = (rot+1) % 3; mApp.rotateScreen(rot);
	int options = 0;
	if (quickSelect) options |= FileChooser.QUICK_SELECT;
	if (showTree) options |= FileChooser.DIRECTORY_TREE;
	if (multiSelect) options |= FileChooser.MULTI_SELECT;
	if (explorer) options |= FileChooser.EXPLORER_TYPE;
	if (type == 1) options |= FileChooser.DIRECTORY_SELECT;
	else options |= browseOnly|asABrowser ? FileChooser.BROWSE : FileChooser.OPEN;
	FileChooser f = 
		useImages ?
		new ImageFileChooser(options,initial,aFile):
		new FileChooser(options,initial,aFile);
	String [] ms = mString.split(masks,',');
	for (int i = 0; i<ms.length; i++) f.addMask(ms[i]);
	//if (!useImages) f.addMask("*.* - All Files.");
	f.title = chooserTitle;
	if (doExec) f.exec();
	else f.show();
	if (f.waitUntilClosed() == f.IDOK){
		if (asABrowser) return;
		MessageBox mb = new MessageBox("Chosen","You chose:\n"+f.getChosen()+((f.chosenFiles.size() > 1) ? "\nand more." : ""),MessageBox.MBOK);
		mb.execute();
	}
}
//===================================================================
public void run()
//===================================================================
{
	//int rot = 0;
	while(true){
		Editor ed = getEditor(0);
		int doDemo = ed.execute();
		if (doDemo == Form.IDCANCEL) break;
		runIt();
		if (asABrowser) break;
	}	
	if (exitSystem) System.exit(0);
}

public static void main(String [] args)
{
	Application.startApplication(args);
	//mApp.rotateScreen(mApp.ROTATE_COUNTER_CLOCKWISE);
	new FileChooserDemo().run();
	System.exit(0);
}
//##################################################################
}
//##################################################################

