package eve.ui.table.data.registry;
import eve.fx.IImage;
import eve.io.File;
import eve.sys.IRegistryKey;
import eve.ui.table.TreeModelAdapter;

//##################################################################
public class RegistryTreeModel extends TreeModelAdapter{
//##################################################################

public IRegistryKey root = null;
	
public RegistryTreeModel(IRegistryKey root)
{
	this.root = root.getRootKey();
}
{
	dynamicCanExpand = true;
}
//-------------------------------------------------------------------
protected IImage getIcon(Object parentNode,int childIndex)
//-------------------------------------------------------------------
{
	if (parentNode == null)
		return (IImage)File.getNewFile().getInfo(File.INFO_DEVICE_ICON).getObject(IImage.class);
	else
		return super.getIcon(parentNode,childIndex);
}
//-------------------------------------------------------------------
protected String getDisplayString(Object parentNode,int childIndex)
//-------------------------------------------------------------------
{
	if (parentNode == null) 
		return root.getKeyName();
	else
		return ((IRegistryKey)parentNode).getSubKey(childIndex);
}
//-------------------------------------------------------------------
protected byte getFlags(Object parentNode,int childIndex,byte savedFlags)
//-------------------------------------------------------------------
{
	Object created = createObjectFor(parentNode,childIndex);
	if (created instanceof IRegistryKey){
		int num = ((IRegistryKey)created).getSubKeyCount();
		if (num != 0) return (byte)(CanExpand|IsNode);
		else return (byte)IsNode;
	}
	return savedFlags;
}

protected long [] getChildIndexes(Object parent)
{
	if (parent instanceof IRegistryKey){
		long[] ret = (long [])((IRegistryKey)parent).getSubKeys(IRegistryKey.GET_INDEXES_AS_LONGS);
		return ret; 
	}else{
		return new long[]{1L,2L,3L,4L,5L,6L};
	}
}

public long[] getKeyIndexes(Object parent)
{
	return getChildIndexes(parent);
}
/*
public boolean getSubKeyName(Object parent, long childRef,CharArray destination)
{
	int idx = (int)(childRef & 0xffffffff);
	if (parent instanceof IRegistryKey)
		return ((RegistryKey)parent).getSubKey(idx,destination);
	else{
		destination.append(Registry.roots[idx]);
		return true;
	}
		
}
*/
protected int getChildCount(Object parent)
{
	if (parent instanceof IRegistryKey){
		return ((IRegistryKey)parent).getSubKeyCount();
	}
	return 0;
}
//-------------------------------------------------------------------
protected Object createObjectFor(Object parent,int child)
//-------------------------------------------------------------------
{
	if (!(parent instanceof IRegistryKey)) return root;
	IRegistryKey rk = (IRegistryKey)parent;
	return rk.getSubKey(rk.getSubKey(child));
}
/*
public RegistryKey getSubKey(RegistryKey parent, long childRef)
{
	return (RegistryKey)createObjectFor(parent,(int)(childRef & 0xffffffff));
}
*/
public IRegistryKey getKeyAt(int whichLine)
{
	Object created = createObjectFor(getParentObject(whichLine),getIndexFor(whichLine));
	if (created instanceof IRegistryKey) return (IRegistryKey)created;
	return null;
}
//##################################################################
}
//##################################################################

