package eve.util;
/**
* A ByteEncodable object is one that can encode its data as a sequence of
*  bytes.
**/
//##################################################################
public interface ByteEncodable{
//##################################################################
/**
 * This requests the Object to encode itself as a stream of bytes which is appended 
 * to the destination ByteArray. If the destination ByteArray is null, then the object
 * should report how many bytes <b>would</b> be used if the object was encoded.
 * @param dest The destination ByteArray, or null to determine the number of bytes needed to encode.
 * @return The number of bytes appended to the ByteArray or the number of bytes needed to encode.
 */
public int encodeBytes(ByteArray dest);
//##################################################################
}
//##################################################################



