/*********************************************************************************
 *  Ewe Virtual Machine - Version 1.14, January 24, 2002                         *
 *  Copyright (C) 1999-2002 Michael L Brereton <michael_brereton@ewesoft.com>    *
 *  All Rights Reserved                                                          *
 *                                                                               *
 *  This library and virtual machine is free software; you can redistribute      *
 *  it and/or modify it under the terms of the Amended GNU Lesser General        *
 *  Public License distributed with this software.                               *
 *                                                                               *
 *  Under this license, linking this library or part thereof with other files to *
 *  produce an executable does not in itself require the executable to be        *
 *  covered by the GNU Lesser General Public License.                            *
 *                                                                               *
 *  This library and virtual machine is distributed in the hope that it will     *
 *  be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                         *
 *                                                                               *
 *  You should have received a copy of the License along with this software;     *
 *  if not, please download it at: www.ewesoft.com/LGPL.txt                      *
 *                                                                               *
 *********************************************************************************/
package eve.util;
/**
* This interface is used to compare two Object values which are referenced
* somehow via unique integer values. For example the integer values could
* be indexes of an array, or they could be positions in a large data file.
* CompareInts objects are used in Utils.sort() methods, where an array of integer
* values are sorted.
**/
//##################################################################
public interface CompareInts{
//##################################################################
/**
* This should return <0 if one is considered less than two, >0 if one is
* considered more than two, and 0 if they are considered equal.
**/
public int compare(int one,int two);
//##################################################################
}
//##################################################################

