package eve.util;
import java.util.Vector;

import eve.sys.Vm;

//##################################################################
public class TextDecoder{
//##################################################################
Vector all = new Vector();
//===================================================================
public TextDecoder(String str)
//===================================================================
{
	SubString ss = new SubString().set(str);
	ss.split('&',all);
	int num = all.size();
	for (int i = 0; i<num; i++){
		SubString sub = (SubString)all.get(i);
		int end = sub.start+sub.length;
		int did = 0;
		boolean hitEquals = false;
		for (int s = sub.start, d = sub.start; s<end;){
			char c = sub.data[s++];
			if (hitEquals){
				if (c == '+') c = ' ';
				else if (c == '%' && s+1<end) {
					char h = sub.data[s++];
					if (h >= 'a' && h <= 'z') h ^= 0x20; // Convert to caps.
					if (h >= '0' && h <= '9') h -= '0';
					else h -= 'A'-(char)10;
					c = (char)((h & 0xf) << 4);
					h = sub.data[s++];
					if (h >= 'a' && h <= 'z') h ^= 0x20; // Convert to caps.
					if (h >= '0' && h <= '9') h -= '0';
					else h -= 'A'-(char)10;
					c |= (h & 0xf);
					did+=1;
				}
			}else if (c == '=') hitEquals = true;
			sub.data[d++] = c;
		}
		sub.length -= did*2;
	}
}

private static boolean isNamed(String name, char [] data,int start,int length)
{
	char[] src = Vm.getStringChars(name);
	int max = src.length;
	int d = 0;
	int i = 0;
	for (i = 0; i<length && d<max; i++){
		char c = data[start+i];
		if (c == '+') c = ' ';
		else if (c == '%' && i<length-2) {
			char h = data[start+(++i)];
			if (h >= 'a' && h <= 'z') h ^= 0x20; // Convert to caps.
			if (h >= '0' && h <= '9') h -= '0';
			else h -= 'A'-(char)10;
			c = (char)((h & 0xf) << 4);
			h = data[start+(++i)];
			if (h >= 'a' && h <= 'z') h ^= 0x20; // Convert to caps.
			if (h >= '0' && h <= '9') h -= '0';
			else h -= 'A'-(char)10;
			c |= (h & 0xf);
		}
		if (src[d++] != c) return false;
	}
	return i == length && d == max;
}
//===================================================================
public static String decode(char [] data,int start,int length)
//===================================================================
{
	char [] nd = new char[data.length];
	int d = 0;
	for (int i = 0; i<length; i++){
		char c = data[start+i];
		if (c == '+') c = ' ';
		else if (c == '%' && i<length-2) {
			char h = data[start+(++i)];
			if (h >= 'a' && h <= 'z') h ^= 0x20; // Convert to caps.
			if (h >= '0' && h <= '9') h -= '0';
			else h -= 'A'-(char)10;
			c = (char)((h & 0xf) << 4);
			h = data[start+(++i)];
			if (h >= 'a' && h <= 'z') h ^= 0x20; // Convert to caps.
			if (h >= '0' && h <= '9') h -= '0';
			else h -= 'A'-(char)10;
			c |= (h & 0xf);
		}
		nd[d++] = c;
	}
	return new String(nd,0,d);
}
//===================================================================
public int size() {return all.size();}
//===================================================================
/**
 * Get the index of the named value.
 * @param name The name of the value.
 * @return The index of the value, or -1 if it is not present.
 */
//===================================================================
public int getIndexOf(String name)
//===================================================================
{
	int num = all.size();
	for (int i = 0; i<num; i++){
		SubString sub = (SubString)all.get(i);
		if (isNamed(sub,name)) return i;
	}
	return -1;
}

/**
 * Get the value of the name.
  * @param name The name of the value.
  * @return The value or null if it is not set.
 */
//===================================================================
public String getValue(String name)
//===================================================================
{
	int num = all.size();
	for (int i = 0; i<num; i++){
		SubString sub = (SubString)all.get(i);
		if (isNamed(sub,name)) return getValueOf(sub);
	}
	return null;
}

//-------------------------------------------------------------------
int getEqualIndex(int index)
//-------------------------------------------------------------------
{
	if (index < 0 || index > size()) return -1;
	SubString sub = (SubString)all.get(index);
	return SubString.indexOf('=',sub.data,sub.start,sub.length,sub.start,0);
}
/**
 * The name of the value at the specified index.
 * @param index 
 * @return The name at the index.
 */
//===================================================================
public String getName(int index)
//===================================================================
{
	int id = getEqualIndex(index);
	if (id == -1) return null;
	SubString sub = (SubString)all.get(index);
	return decode(sub.data,sub.start,id-sub.start);	
}
/**
 * The value at the specified index.
 * @param index 
 * @return  The value at the specified index.
 */
//===================================================================
public String getValue(int index)
//===================================================================
{
	int id = getEqualIndex(index);
	if (id == -1) return null;
	SubString sub = (SubString)all.get(index);
	return new String(sub.data,id+1,sub.length-(id-sub.start)-1);
}
//===================================================================
public static boolean isNamed(SubString sub,String name)
//===================================================================
{
	int id = SubString.indexOf('=',sub.data,sub.start,sub.length,sub.start,0);
	if (id == -1) return false;
	return isNamed(name,sub.data,sub.start,id-sub.start);
	//String nameIs = decode(sub.data,sub.start,id-sub.start);
	//return name.equals(nameIs);	
}
//===================================================================
public static String getValueOf(SubString sub)
//===================================================================
{
	int id = SubString.indexOf('=',sub.data,sub.start,sub.length,sub.start,0);
	if (id == -1) return null;
	return new String(sub.data,id+1,sub.length-(id-sub.start)-1);
}

//===================================================================
public String toString()
//===================================================================
{
	String s = "";
	for (int i = 0; i<all.size(); i++){
		s += "["+all.get(i)+"]";
	}
	return s;
}

//===================================================================
public void setValue(String name,String value)
//===================================================================
{
	deleteValue(name);
	String s = name+"="+value;
	all.add(new SubString().set(s));
}
//===================================================================
public void deleteValue(String name)
//===================================================================
{
	int idx = getIndexOf(name);
	if (idx == -1) return;
	all.removeElementAt(idx);
}
/**
 * Re-encode the decoded text into a String.
 * @return The encoded string.
 */
//===================================================================
public String encode()
//===================================================================
{
	TextEncoder te = new TextEncoder();
	int num = all.size();
	for (int i = 0; i<num; i++){
		String name = getName(i);
		String value = getValue(i);
		te.addValue(name,value);
	}
	return te.toString();
}
//##################################################################
}
//##################################################################

